import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Cooperate, CooperateParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商务合作
 */
export async function pageCooperate(params: CooperateParam) {
  const res = await request.get<ApiResult<PageResult<Cooperate>>>(
    MODULES_API_URL + '/booking/cooperate/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商务合作列表
 */
export async function listCooperate(params?: CooperateParam) {
  const res = await request.get<ApiResult<Cooperate[]>>(
    MODULES_API_URL + '/booking/cooperate',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商务合作
 */
export async function addCooperate(data: Cooperate) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商务合作
 */
export async function updateCooperate(data: Cooperate) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商务合作
 */
export async function removeCooperate(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商务合作
 */
export async function removeBatchCooperate(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/cooperate/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商务合作
 */
export async function getCooperate(id: number) {
  const res = await request.get<ApiResult<Cooperate>>(
    MODULES_API_URL + '/booking/cooperate/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
